import java.awt.Choice;
import java.util.*;

/*
 *
 * ChoiceData
 *
 * This class extends the choice control and adds the ability
 *   to associate a data element with each item in the choice
 *   list.
 */
public class ChoiceData extends Choice
{
	protected Vector Data = new Vector();

	public void addItemData(String item, Object obj)
	{
		addItem(item);					// add item to choices

		Data.addElement(obj);			// add date to the data list
	}

	public void selectByData(Object obj)
	{
		// find the data in the data list
		int index = Data.indexOf(obj);

		// select the corresponding element
		select(index);
	}

	public Object getSelectedData()
	{
		return getSelectedIndex() >= 0 ? 
				Data.elementAt(getSelectedIndex()) : null;
	}

	public void load(Vector data)
	{
		// add each element to the choice list and the data list
		for (Enumeration enum = data.elements(); 
				enum.hasMoreElements();)
		{
			Object ob = enum.nextElement();

			addItemData(ob.toString(), ob);
		}
	}
}
