import java.util.Vector;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;

/*
 *
 * Department
 *
 * This class takes care of reading and writing an department entry 
 *   to the database.
 *
 */
public class Department 
{
	public String Code;
	public String Name;

	public Department()
	{
		clear();
	}

	public String toString()
	{
		return Name;
	}

	public void clear()
	{
		Code = Name = "";
	}

	public void set(String Code, String Name)
	{
		this.Code = Code.toUpperCase();
		this.Name = Name;
	}

	public void set(Department dept)
	{
		this.Code = dept.Code.toUpperCase();
		this.Name = dept.Name;
	}

	public void setCode(String Code)
	{
		this.Code = Code;
	}

	public void insert(Database db)
	{
		Write(db, "insert into DEPARTMENT values('" 
				+ Code + "','" + Name + "')");
	}

	public void update(Database db)
	{
		Write(db, "update DEPARTMENT set DEPT_NAME = '" + Name + 
				"' where DEPT_CODE = '" + Code + "'");
	}

	public boolean read(Database db)
	{
		boolean retval = false;			// assume database error
		String command = "select * from DEPARTMENT where DEPT_CODE = '" + 
				Code + "'";
		Variant type = new Variant();
		Variant options = new Variant();

		type.putShort(Constants.dbOpenDynaset);
		options.putShort(Constants.dbReadOnly);

		// create the recordset and get the number of records returned
		Recordset recordset = db.OpenRecordset(command, type, options);

		int recordCount = recordset.getRecordCount();

		// retrieve the first row
		if (recordCount > 0) {
			recordset.MoveFirst();

			// get the fields of the row
			getFields(recordset.getFields());

			retval = true;
		}

		return retval;
	}

	public static boolean readAll(Database db, Vector departmentList)
	{
		boolean retval = false;			// assume database error
		Variant type = new Variant();
		Variant options = new Variant();
		Variant fieldName = new Variant();
		Variant fieldValue = new Variant();

		type.putShort(Constants.dbOpenTable);
		options.putShort(Constants.dbReadOnly);

		// create the recordset and get the number of records returned
		Recordset recordset = db.OpenRecordset("DEPARTMENT", type, options);

		int recordCount = recordset.getRecordCount();

		// retrieve the first row
		if (recordCount > 0)
			recordset.MoveFirst();

		// read all of the records
		while (recordCount > 0)
		{
			Department dept = new Department();

			// get the fields of the row
			dept.getFields(recordset.getFields());

			// save the department
			departmentList.addElement(dept);

			// move the element indexing
			recordset.MoveNext();
			recordCount--;
		}

		return retval;
	}

	private void getFields(Fields fields)
	{
		Variant fieldName = new Variant();
		Variant fieldValue = new Variant();
		_Field field;

		// retrieve all of the information and store it
		fieldName.putString("DEPT_CODE");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		Code = fieldValue.toString();

		fieldName.putString("DEPT_NAME");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		Name = fieldValue.toString();
	}

	private void Write(Database db, String command)
	{
		Variant options = new Variant();
		options.putShort(Constants.dbFailOnError);

		db.Execute(command, options);
	}
}
