import java.applet.*;
import java.awt.*;
import java.net.URL;
import java.util.*;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;
import UserInformation;
import LoginPanel;
import ControlPanel;
import AdministrationPanel;

public class DevRequest extends Applet implements Observer
{
	protected _DBEngine dbEngine;
	protected Database db;
	protected boolean DatabaseOk;
	protected CardLayout layout;
	protected UserInformation UserInfo = new UserInformation();

	public void init()
	{
		resize(750, 380);

		DatabaseOk = OpenDatabase();

		if (DatabaseOk) {
			UserInfo.addObserver(this);

			AllocatePanels();
		}
	}

	public void update(Observable o, Object arg)
	{
		// if the user information has changed, assume login
		//   has been successfull and go to control
		if (o instanceof UserInformation)
			layout.show(this, UserInfo.NextScreen);
	}

	protected boolean OpenDatabase()
	{
		URL dbURL;
		try {
			// otherwise generate it relative to the applet
			dbURL = new java.net.URL(getDocumentBase(), 
					"DevDb.mdb");
		}
		catch(Exception e) {
			showStatus("Error: " + e.getMessage());
			return false;
		}

		// strip "file:/" from dbURL
		String filename = dbURL.getFile().substring(1);

		// create the database engine
		dbEngine = dao_dbengine.create();

		// create Variants that will hold parameters that 
		// will be passed to OpenDatabase
		Variant exclusive = new Variant();
		Variant readOnly = new Variant();
		Variant source = new Variant();

		// set parameters for call to OpenDatabase
		exclusive.putBoolean(false);
		readOnly.putBoolean(false);
		source.putString("");

		// open the database for non-exclusive access
		db = dbEngine.OpenDatabase(filename, exclusive, readOnly, source);

		return true;
	}

	protected void AllocatePanels()
	{
		// the main layout manager will be a card layout
		layout = new CardLayout();
		setLayout(layout);

		add(UserInformation.LOGIN, new LoginPanel(db, UserInfo));
		add(UserInformation.CONTROL, new ControlPanel(db, UserInfo));
		add(UserInformation.ADMINISTRATION, new AdministrationPanel(db, UserInfo));
	}
}
