import java.awt.*;
import java.applet.*;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;
import UserInformation;

/*
 * LoginPanel
 *
 * This panel is used to display the login information and verify
 *   the user name and password.
 */
public class LoginPanel extends StatusPanel
{
	protected Database db;
	protected UserInformation UserInfo;
	protected TextField UserNameField = new TextField(8);
	protected TextField PasswordField = new TextField(8);

	public LoginPanel(Database db, UserInformation UserInfo)
	{
		super();

		// save the passed in information
		this.db = db;
		this.UserInfo = UserInfo;

		// make a grid bag layout for the panel
		GridBagLayout layout = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		setLayout(layout);

		// put a little space above and below the controls
		gbc.insets.top = gbc.insets.bottom = 4;

		// create the controls for this panel
		gbc.weightx = 1.0;				// center 2 controls side-by-side
		gbc.anchor = GridBagConstraints.EAST;
		Label lbl = new Label("User Name:", Label.RIGHT);
		layout.setConstraints(lbl, gbc);
		add(lbl);

		// make the text field the last on the line
		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		layout.setConstraints(UserNameField, gbc);
		add(UserNameField);

		gbc.anchor = GridBagConstraints.EAST;
		gbc.gridwidth = 1;
		lbl = new Label("Password:", Label.RIGHT);
		layout.setConstraints(lbl, gbc);
		add(lbl);

		// make the text field the last on the line
		gbc.anchor = GridBagConstraints.WEST;
		gbc.gridwidth = GridBagConstraints.REMAINDER;
		layout.setConstraints(PasswordField, gbc);
		PasswordField.setEchoCharacter('*');
		add(PasswordField);

		// add the button on its own line
		gbc.anchor = GridBagConstraints.CENTER;
		Button btn = new Button("Logon");
		layout.setConstraints(btn, gbc);
		add(btn);

		// put all of the space at the bottom
		gbc.fill = GridBagConstraints.BOTH;
		gbc.weighty = 1.0;
		Panel space = new Panel();
		layout.setConstraints(space, gbc);
		add(space);
	}

	public boolean action(Event evt, Object obj)
	{
		boolean retval = false;

		if ("Logon".equals(obj))
		{
			// make sure there is something in both fields
			if ((UserNameField.getText().length() > 0) && 
					(PasswordField.getText().length() > 0))
			{
				if (ValidateUser())
					UserInfo.signalNextScreen();
				else
					setStatus(UserNameField.getText() + " could not be log on.");
			}
			else
				setStatus("Both User Name and Password must be specified.");
		}

		return retval;
	}

	protected boolean ValidateUser()
	{
		boolean retval = false;			// assume no logon
		String command = "select * from OPERATOR where USER_NAME = '" +
				UserNameField.getText().toLowerCase() + 
				"' and PASSWORD = '" + 
				PasswordField.getText().toLowerCase() + "'";
		Variant type = new Variant();
		Variant options = new Variant();

		type.putShort(Constants.dbOpenDynaset);
		options.putShort(Constants.dbEditAdd);

		// create the recordset
		Recordset recordset = db.OpenRecordset(command, type, options);

		// if there was a record returned, then get the user's info
		if (recordset.getRecordCount() > 0)
		{
			Variant fieldName = new Variant();
			Variant fieldValue = new Variant();

			// retrieve the first (and only) row
			recordset.MoveFirst();

			// get the fields of the row
			Fields fields = recordset.getFields();
			_Field field;

			// retrieve all of the information and store it
			fieldName.putString("USER_NAME");
			field = fields.getItem(fieldName);
			fieldValue = field.getValue();
			UserInfo.UserName = fieldValue.toString();

			fieldName.putString("FIRST_NAME");
			field = fields.getItem(fieldName);
			fieldValue = field.getValue();
			UserInfo.FirstName = fieldValue.toString();

			fieldName.putString("LAST_NAME");
			field = fields.getItem(fieldName);
			fieldValue = field.getValue();
			UserInfo.LastName = fieldValue.toString();

			fieldName.putString("ACCESS_LEVEL");
			field = fields.getItem(fieldName);
			fieldValue = field.getValue();
			UserInfo.setAccessLevel(fieldValue.toString());

			retval = true;				// found an entry
		}

		return retval;
	}
}
