import java.util.Vector;
import dao_dbengine;
import dao3032.*;
import com.ms.com.Variant;

/*
 *
 * Operator
 *
 * This class takes care of reading and writing an operator entry 
 *   to the database.
 *
 */
public class Operator 
{
	// these are the constants that should be in ACCESS_LEVEL
	public final static String ADMINISTRATOR = "A";
	public final static String EXECUTIVE = "E";
	public final static String MANAGER = "M";
	public final static String PROGRAMMER = "P";
	public final static String GUEST = "G";

	public String UserName;
	public String Password;
	public String FirstName;
	public String LastName;
	public String AccessLevel;

	public Operator()
	{
		clear();
	}

	public String toString()
	{
		return FirstName + " " + LastName;
	}

	public void clear()
	{
		UserName = Password = FirstName = LastName = AccessLevel = "";
	}

	public void set(String UserName, String Password, String FirstName,
			String LastName, String AccessLevel)
	{
		this.UserName = UserName;
		this.Password = Password;
		this.FirstName = FirstName;
		this.LastName = LastName;
		this.AccessLevel = (AccessLevel.substring(0,1)).toUpperCase();
	}

	public void set(Operator op)
	{
		this.UserName = op.UserName;
		this.Password = op.Password;
		this.FirstName = op.FirstName;
		this.LastName = op.LastName;
		this.AccessLevel = op.AccessLevel.substring(0,1).toUpperCase();
	}

	public void setUserName(String UserName)
	{
		this.UserName = UserName;
	}

	public void insert(Database db)
	{
		write(db, "insert into OPERATOR values('" + UserName + 
				"','" + Password + "','" + FirstName + "','" +
				LastName + "','" + AccessLevel + "')");
	}

	public void update(Database db)
	{
		write(db, "update OPERATOR set PASSWORD = '" + Password + 
				"', FIRST_NAME = '" + FirstName + 
				"', LAST_NAME = '" + LastName + 
				"', ACCESS_LEVEL = '" + AccessLevel + 
				"' where USER_NAME = '" + UserName + "'");
	}

	public boolean read(Database db)
	{
		boolean retval = false;			// assume database error
		String command = "select * from OPERATOR where USER_NAME = '" + 
				UserName + "'";
		Variant type = new Variant();
		Variant options = new Variant();

		type.putShort(Constants.dbOpenDynaset);
		options.putShort(Constants.dbReadOnly);

		// create the recordset and get the number of records returned
		Recordset recordset = db.OpenRecordset(command, type, options);

		int recordCount = recordset.getRecordCount();

		// retrieve the first row
		if (recordCount > 0) {
			recordset.MoveFirst();

			// get the fields of the row
			getFields(recordset.getFields());

			retval = true;
		}

		return retval;
	}

	public static boolean readAll(Database db, Vector operatorList)
	{
		boolean retval = false;			// assume database error
		Variant type = new Variant();
		Variant options = new Variant();

		type.putShort(Constants.dbOpenTable);
		options.putShort(Constants.dbReadOnly);

		// create the recordset and get the number of records returned
		Recordset recordset = db.OpenRecordset("OPERATOR", type, options);

		int recordCount = recordset.getRecordCount();

		// retrieve the first row
		if (recordCount > 0)
			recordset.MoveFirst();

		// read all of the records
		while (recordCount > 0)
		{
			Operator op = new Operator();

			// get the fields of the row
			op.getFields(recordset.getFields());

			// save the operator
			operatorList.addElement(op);

			// move the element indexing
			recordset.MoveNext();
			recordCount--;
		}

		return retval;
	}

	private void getFields(Fields fields)
	{
		Variant fieldName = new Variant();
		Variant fieldValue = new Variant();
		_Field field;

		// retrieve all of the information and store it
		fieldName.putString("USER_NAME");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		UserName = fieldValue.toString();

		fieldName.putString("PASSWORD");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		Password = fieldValue.toString();

		fieldName.putString("FIRST_NAME");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		FirstName = fieldValue.toString();

		fieldName.putString("LAST_NAME");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		LastName = fieldValue.toString();

		fieldName.putString("ACCESS_LEVEL");
		field = fields.getItem(fieldName);
		fieldValue = field.getValue();
		AccessLevel = fieldValue.toString();
	}

	private void write(Database db, String command)
	{
		Variant options = new Variant();
		options.putShort(Constants.dbFailOnError);

		db.Execute(command, options);
	}
}
