import java.awt.*;
import java.applet.Applet;
import dao_dbengine;
import dao3032.*;
import com.ms.com.*;

/*
 *
 * StatusPanel
 *
 * This class provides a simple means to display a status message to 
 *   the applet's status bar.
 */
public class StatusPanel extends Panel
{
	protected boolean hasBorder = false;

	public StatusPanel()
	{
		hasBorder = false;
	}

	public StatusPanel(boolean hasBorder)
	{
		this.hasBorder = hasBorder;
	}

	public void paint(Graphics g)
	{
		if (hasBorder)
		{
			// draw a rectangle around the panel
			Rectangle rect = bounds();
			g.drawRect(0, 0, rect.width - 1, rect.height - 1);
		}
	}

	protected void setStatus(String msg)
	{
		Applet applet = getAppletParent();
		applet.showStatus(msg);
	}

	protected void setStatus(ComException comE)
	{
		Applet applet = getAppletParent();

		if (applet instanceof DevRequest)
		{
			Variant comError = new Variant();
			comError.putShort((short)(comE.getHResult()));

			Errors errs = ((DevRequest)applet).dbEngine.getErrors();
			dao3032.Error err = errs.getItem(comError);

			applet.showStatus("DB Error: " + err.getDescription());
		}
		else
			applet.showStatus(comE.getMessage());
	}

	private Applet getAppletParent()
	{
		java.awt.Container parent = getParent();

		while (!(parent instanceof Applet))
			parent = parent.getParent();

		return (Applet)parent;
	}
}

